<?php
/***************************************************************************
* 	                   dl_overview.php
*                            -------------------
*   copyright            : (C) 2005 OXPUS.de
*   email                : webmaster@oxpus.de
*
***************************************************************************/

/***************************************************************************
*
*   This program is free software; you can redistribute it and/or modify
*   it under the terms of the GNU General Public License as published by
*   the Free Software Foundation; either version 2 of the License, or
*   (at your option) any later version.
*
***************************************************************************/

define('IN_PHPBB', true);
$phpbb_root_path = './';
include($phpbb_root_path.'extension.inc');
include($phpbb_root_path.'common.'.$phpEx);
include($phpbb_root_path.'includes/bbcode.'.$phpEx);
include($phpbb_root_path.'includes/functions_post.'.$phpEx);
include($phpbb_root_path.'includes/functions_downloads.'.$phpEx);

$userdata = session_pagestart($user_ip, PAGE_INDEX);
init_userprefs($userdata);

$sort_by = ( $HTTP_POST_VARS['sort_by'] ) ? intval($HTTP_POST_VARS['sort_by']) : intval($HTTP_GET_VARS['sort_by']);
$order = ( $HTTP_POST_VARS['order'] ) ? $HTTP_POST_VARS['order'] : $HTTP_GET_VARS['order'];

$page_title = $lang['Dl_overview'];
include($phpbb_root_path . 'includes/page_header.'.$phpEx);

$dl_auth = array();
$dl_auth = dl_auth('all_cats', 0);
$index = create_dl_overview_index();
$download_dir = $board_config['download_dir'];
set_auto_traffic();
reset_dl_klicks();


$template->set_filenames(array(
	'body' => 'dl_overview_body.tpl')
);

if ( $userdata['session_logged_in'])
{
	$user_traffic = $userdata['user_traffic'];
}
else
{
	$user_traffic = "0";
}

$sql_rate = "SELECT dl_id, user_id FROM " . DL_RATING_TABLE;
if (!$result_rate = $db->sql_query($sql_rate))
{
	message_die(GENERAL_ERROR, 'Could not fetch ratings', '', __LINE__, __FILE__, $sql_rate);
}

$ratings = array();
while ($row_rate = $db->sql_fetchrow($result_rate))
{
	$ratings[$row_rate['dl_id']][] = $row_rate['user_id'];
}
$db->sql_freeresult($result_rate);

$s_sort_by = '<select name="sort_by">';
$s_sort_by .= '<option value="0">'.$lang['Dl_default_sort'].'</option>';
$s_sort_by .= '<option value="1">'.$lang['Dl_file_description'].'</option>';
$s_sort_by .= '<option value="2">'.$lang['Dl_file_name'].'</option>';
$s_sort_by .= '<option value="3">'.$lang['Dl_klicks'].'</option>';
$s_sort_by .= '<option value="4">'.$lang['Dl_free'].'</option>';
$s_sort_by .= '<option value="5">'.$lang['Dl_extern'].'</option>';
$s_sort_by .= '<option value="6">'.$lang['Dl_file_size'].'</option>';
$s_sort_by .= '<option value="7">'.$lang['Last_updated'].'</option>';
$s_sort_by .= '<option value="8">'.$lang['Dl_rating'].'</option>';
$s_sort_by .= '</select>';
$s_sort_by = str_replace('value="'.$sort_by.'">', 'value="'.$sort_by.'" SELECTED>', $s_sort_by);

$s_order = '<select name="order">';
$s_order .= '<option value="ASC">'.$lang['Sort_Ascending'].'</option>';
$s_order .= '<option value="DESC">'.$lang['Sort_Descending'].'</option>';
$s_order .= '</select>';
$s_order = str_replace('value="'.$order.'">', 'value="'.$order.'" SELECTED>', $s_order);

switch ($sort_by)
{
	case 1:
		$sql_sort_by = 'description';
		break;
	case 2:
		$sql_sort_by = 'file_name';
		break;
	case 3:
		$sql_sort_by = 'klicks';
		break;
	case 4:
		$sql_sort_by = 'free';
		break;
	case 5:
		$sql_sort_by = 'extern';
		break;
	case 6:
		$sql_sort_by = 'file_size';
		break;
	case 7:
		$sql_sort_by = 'change_time';
		break;
	case 8:
		$sql_sort_by = 'rating';
		break;
	default:
		$sql_sort_by = 'sort';
}

$sql_order = $order;

$template->assign_vars(array(
	"L_DESCRIPTION" => $lang['Dl_file_description'],
	"L_DL_CAT" => $lang['Dl_cat_name'],
	"L_DL_FILES" => $lang['Dl_cat_files'],
	"L_DESCRIPTION" => $lang['Dl_file_description'],
	"L_STATUS" => $lang['Dl_info'],
	"L_KLICKS" => $lang['Dl_klicks'],
	"L_OVERALL_KLICKS" => $lang['Dl_overall_klicks'],
	"L_SIZE" => $lang['Dl_file_size'],
	"L_NAME" => $lang['Dl_name'],
	"L_TOP" => $lang['Back_to_top'],
	"L_SORT_BY" => $lang['Sort_by'],
	"L_ORDER" => $lang['Order'],
	"L_RATING" => $lang['Dl_rating'],
	"L_DOWNLOADS" => $lang['Dl_cat_title'],

	"S_SORT_BY" => $s_sort_by,
	"S_ORDER" => $s_order,

	"U_DOWNLOADS" => append_sid("dl_overview.$phpEx"),
	"U_DL_INDEX" => append_sid("downloads.$phpEx"),

	"COLSPAN" => $colspan,
	"PAGE_NAME" => $page_title)
);

if (count($index) > 0)
{
	$i = 0;
	foreach(array_keys($index) as $key)
	{
		$cat_id = $key;

		$sql = "SELECT * FROM " . DOWNLOADS_TABLE . "
			WHERE cat = $cat_id
			ORDER BY $sql_sort_by $sql_order";
		if (!$result = $db->sql_query($sql))
		{
			message_die(GENERAL_ERROR, 'Could not fetch data for new/changes downloads', '', __LINE__, __FILE__, $sql_mini_icon);
		}
		$cat_dl = $db->sql_numrows($result);

		if ($cat_dl > 0)
		{
			$cat_name = $index[$cat_id]['cat_name'];
			$cat_name = str_replace('&nbsp;&nbsp;|', '', $cat_name);
			$cat_name = str_replace('___&nbsp;', '', $cat_name);
			$cat_desc = $index[$cat_id]['description'];
			$cat_view = $index[$cat_id]['nav_path'];
			$cat_path = $index[$cat_id]['cat_path'];

			$count_new = 0;
			$count_edit = 0;
			$mini_icon_new = $mini_icon_edit = '';

			$template->assign_block_vars('catrow', array(
				'U_CAT_VIEW' => $cat_view,
				'CAT_DESC' => $cat_desc,
				'CAT_NAME' => $cat_name)
			);

			while ($row = $db->sql_fetchrow($result))
			{
				$description = stripslashes($row['description']);
				$description = preg_replace('#(<)([\/]?.*?)(>)#is', "&lt;\\2&gt;", $description);
				$description = preg_replace('/\:[0-9a-z\:]+\]/si', ']', $description);
				$description = str_replace("\n", "\n<br />\n", $description);
				$file_id = $row['id'];
				$file_klicks = $row['klicks'];
				$file_name_name = $this_dl['file_name'];
				$file_overall_klicks = $row['overall_klicks'];
				$file_free = $row['free'];
				$file_traffic = $row['file_traffic'];
				$file_extern = $row['extern'];
				$description = '<a class="gen" href="'.append_sid("dl_details.$phpEx?view=detail&amp;id=" . $file_id . "&amp;cat=" . $row[cat]).'">' . $description . '</a>';

				if ($file_extern == "0")
				{
					$file_size = intval($row['file_size']);

					if ($file_size < 1024)
					{
						$file_size_out = $file_size . " byte";
					}
					if ($file_size > 1025)
					{
						$file_size_out = bcdiv($file_size,1024,2) . " kb";
					}
					if ($file_size > 1048575)
					{
						$file_size_out = bcdiv($file_size,1048576,2) . " Mb";
					}
				}
				else
				{
					$file_size_out = $lang['Dl_not_availible'];
				}

				$dl_status = array();
				$dl_status = get_dl_status($file_size, $file_extern, $file_id, $file_name_name, $file_free, $file_klicks, $file_traffic, $cat_id);

				$status = $dl_status['status'];

				$mini_icon_new = ($row['new_edit'] == 1 && ((time() - $row['change_time']) / 86400) <= $board_config['dl_new_time'] && intval($board_config['dl_new_time']) > 0) ? '<img src="'.$images['icon_minipost_new'].'" border="0" />&nbsp;' : '';
				$mini_icon_edit = ($row['new_edit'] == 0 && ((time() - $row['change_time']) / 86400) <= $board_config['dl_new_time'] && intval($board_config['dl_new_time']) > 0) ? '<img src="'.$images['icon_minipost'].'" border="0" />&nbsp;' : '';

				$cat_name = $index[$cat_id]['cat_name'];
				$cat_view = $index[$cat_id]['nav_path'];
				$cat_desc = $index[$cat_id]['description'];

				$hack_version = '&nbsp;'.$row['hack_version'];

				$rating_points = $row['rating'];

				if ($userdata['user_id'] == ANONYMOUS)
				{
					$rating_text = '';
				}
				else if ($rating_points == 0 || !@in_array($userdata['user_id'], $ratings[$file_id]))
				{
					$rating_text = sprintf($lang['Dl_klick_to_rate'], '<a href="'.append_sid("dl_rating.$phpEx?id=$file_id&amp;cat=$cat_id&amp;dlo=1").'" class="gen">', '</a>');
				}
				else
				{
					$rating_text = '';
				}

				$rating_text = create_rating_img($rating_points) . '<br />' . $rating_text;

				$row_class = ( !($i % 2) ) ? $theme['td_class1'] : $theme['td_class2'];

				$template->assign_block_vars('catrow.download', array(
					'ROW_CLASS' => $row_class,
					'DESCRIPTION' => $mini_icon_new.$mini_icon_edit.$description,
					'HACK_VERSION' => $hack_version,
					'STATUS' => $status,
					'FILE_SIZE' => $file_size_out,
					'FILE_KLICKS' => $file_klicks,
					'FILE_OVERALL_KLICKS' => $file_overall_klicks,
					'RATING' => $rating_text)
				);

				$i++;
			}
		}
	}
}

$template->pparse('body');

include($phpbb_root_path . 'includes/dl_footer.'.$phpEx);

include($phpbb_root_path . 'includes/page_tail.'.$phpEx);

?>