<?php

define('IN_PHPBB', true);
$phpbb_root_path = './';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);
include($phpbb_root_path . 'includes/bbcode.'.$phpEx);
include($phpbb_root_path . 'includes/functions_post.'.$phpEx);
include($phpbb_root_path . 'includes/functions_downloads.'.$phpEx);

//
// Set page ID for session management
//
$userdata = session_pagestart($user_ip, PAGE_DOWNLOADS);
init_userprefs($userdata);
//
// End session management
//

$download_dir = $board_config['download_dir'];
$cat = ( isset($_POST['cat']) ) ? intval($_POST['cat']) : intval($_GET['cat']);
$view = ( isset($_POST['view']) ) ? $_POST['view'] : $_GET['view'];
$id = ( isset($_POST['dl']) ) ? intval($_POST['id']) : intval($_GET['id']);

if ($cat == 0 || $id == 0 || $view != 'detail')
{
	redirect(append_sid("downloads.$phpEx"));
}

$dl_auth = array();
$dl_auth = dl_auth('all_cats', 0);
$index = array();
$index = create_dl_overview_index();
set_auto_traffic();
reset_dl_klicks();

//
// Generate page
//
$cat_nav = ($cat != 0) ? create_dl_nav($cat) : '';
$u_dl_top = '&raquo;&nbsp;<a href="'.append_sid("downloads.$phpEx?sort_by=$sort_by&amp;order=$order").'" class="nav">'.$lang['Dl_cat_title'].'</a>';

make_jumpbox('viewforum.'.$phpEx);

$page_title = $lang['Downloads'];

include($phpbb_root_path . 'includes/page_header.'.$phpEx);

$template->set_filenames(array(
	'body' => 'view_dl_body.tpl')
);

$user_id = $userdata['user_id'];
$username = $userdata['username'];

if ( $userdata['session_logged_in'])
{
	$user_traffic = $userdata['user_traffic'];
}
else
{
	$user_traffic = "0";
}

$sql = "SELECT * FROM " . DOWNLOADS_TABLE . "
	WHERE id = $id
		AND cat = $cat";

if(!$result = $db->sql_query($sql))
{
        message_die(GENERAL_ERROR, 'Could not query downloads', '', __LINE__, __FILE__, $sql);
}

while ($sql != '' && $row = $db->sql_fetchrow($result))
{
	$cat_id = $row['cat'];

	$description = make_clickable(smilies_pass(stripslashes($row['description'])));
	$description = ($row['bbcode_uid'] != '') ? bbencode_second_pass($description, $row['bbcode_uid']) : $description;
	$description = str_replace("\n", "\n<br />\n", $description);
	$file_name_name = $row['file_name'];
	$file_id = $row['id'];
	$description = ($row['long_desc'] != "") ? "<a class=\"gen\" href=\"downloads.$phpEx?view=detail&id=" . $file_id . "&cat=" . $row[cat] . "\">" . $description . "</a>" : $description;
	$file_klicks = $row['klicks'];
	$file_overall_klicks = $row['overall_klicks'];
	$file_free = $row['free'];
	$file_extern = $row['extern'];
	$file_traffic = $row['file_traffic'];
	$file_size = $row['file_size'];

	if ($file_extern == "0")
	{
		if ($file_size < 1024)
		{
			$file_size_out = $file_size . " byte";
		}
		if ($file_size > 1025)
		{
			$file_size_out = bcdiv($file_size,1024,2) . " KB";
		}
		if ($file_size > 1048575)
		{
			$file_size_out = bcdiv($file_size,1048576,2) . " MB";
		}
	}
	else
	{
		$file_size_out = $lang['Dl_not_availible'];
	}

	$dl_status = array();
	$dl_status = get_dl_status($file_size, $file_extern, $file_id, $file_name_name, $file_free, $file_klicks, $file_traffic, $cat_id);
	
	$status = $dl_status['status'];
	$file_name = $dl_status['file_name'];

	$mini_icon_new = ($row['new_edit'] == 1 && ((time() - $row['change_time']) / 86400) <= $board_config['dl_new_time'] && intval($board_config['dl_new_time']) > 0) ? '<img src="'.$images['icon_minipost_new'].'" border="0" />&nbsp;' : '';
	$mini_icon_edit = ($row['new_edit'] == 0 && ((time() - $row['change_time']) / 86400) <= $board_config['dl_new_time'] && intval($board_config['dl_new_time']) > 0) ? '<img src="'.$images['icon_minipost'].'" border="0" />&nbsp;' : '';

	$cat_name = $index[$cat_id]['cat_name'];
	$cat_view = $index[$cat_id]['nav_path'];
	$cat_desc = $index[$cat_id]['description'];

	$hack_version = '&nbsp;'.$row['hack_version'];

	$bbcode_uid = $row['bbcode_uid'];
	$long_desc = stripslashes($row['long_desc']);
	$long_desc = ($bbcode_uid != '') ? bbencode_second_pass($long_desc, $bbcode_uid) : $long_desc;
	$long_desc = smilies_pass($long_desc);
	$long_desc = str_replace("\n", "\n<br />\n", $long_desc);

	$hack_author = ( $row['hack_author'] != '' ) ? $row['hack_author'] : 'n/a';
	$hack_author_email = $row['hack_author_email'];
	$hack_author_website = $row['hack_author_website'];
	$hack_dl_url = $row['hack_dl_url'];
	$test = $row['test'];
	$require = $row['req'];
	$todo = $row['todo'];
	$warning = $row['warning'];
	$mod_desc = $row['mod_desc'];
	$mod_list = $row['mod_list'];
	$mod_desc = ( $row['bbcode_uid'] != '' ) ? smilies_pass(bbencode_second_pass(stripslashes($mod_desc), $row['bbcode_uid'])) : smilies_pass(stripslashes($mod_desc));
	$mod_desc = make_clickable($mod_desc);
	$mod_desc = str_replace("\n", "\n<br />\n", $mod_desc);

	$row_class = ( !($i % 2) ) ? $theme['td_class1'] : $theme['td_class2'];

	if ( $row['hacklist'] > 0)
	{
		$template->assign_block_vars('hacklist', array(
			'HACK_AUTHOR' => ( $hack_author_email != '' ) ? '<a href="mailto:'.$hack_author_email.'">'.$hack_author.'</a>' : $hack_author,
			'HACK_AUTHOR_WEBSITE' => ( $hack_author_website != '' ) ? '<a href="'.$hack_author_website.'">Website</a>' : 'n/a',
			'HACK_DL_URL' => ( $hack_dl_url != '' ) ? '<a href="'.$hack_dl_url.'">'.$lang['Dl_download'].'</a>' : 'n/a')
		);

	}

	if ( $mod_list == 1)
	{
		$template->assign_block_vars('modlist', array(
			'MOD_TEST' => $test,
			'MOD_DESC' => $mod_desc)
		);

		if ( $warning != '' )
		{
			$template->assign_block_vars('modwarning', array(
				'MOD_WARNING' => $warning)
			);
		}

		if ( $require != '' )
		{
			$template->assign_block_vars('modrequire', array(
				'MOD_REQUIRE' => $require)
			);
		}

		if ( $todo != '' )
		{
			$template->assign_block_vars('modtodo', array(
				'MOD_TODO' => $todo)
			);
		}
	}

	$sql_rate = "SELECT dl_id, user_id FROM " . DL_RATING_TABLE;
	if (!$result_rate = $db->sql_query($sql_rate))
	{
		message_die(GENERAL_ERROR, 'Could not fetch ratings', '', __LINE__, __FILE__, $sql_rate);
	}

	$ratings = array();
	while ($row_rate = $db->sql_fetchrow($result_rate))
	{
		$ratings[$row_rate['dl_id']][] = $row_rate['user_id'];
	}
	$db->sql_freeresult($result_rate);

	$rating_points = $row['rating'];

	if ($userdata['user_id'] == ANONYMOUS)
	{
		$rating_text = '';
	}
	else if ($rating_points == 0 || !@in_array($userdata['user_id'], $ratings[$file_id]))
	{
		$rating_text = sprintf($lang['Dl_klick_to_rate'], '<a href="'.append_sid("dl_rating.$phpEx?id=$file_id&amp;cat=$cat_id&amp;dlo=0").'" class="gen">', '</a>');
	}
	else
	{
		$rating_text = '';
	}

	$rating_text = create_rating_img($rating_points) . '<br />' . $rating_text;

	if ($view != 'detail')
	{
		$file_klicks .= str_replace('class="gen"', 'class="postlink"', $rating_text_cat);
	}

	$template->assign_block_vars('rating_view', array(
		'L_RATING' => $lang['Dl_rating'],
		'RATING_STRING' => $rating_text)
	);

	$template->assign_block_vars('downloads', array(
		'DESCRIPTION' => $mini_icon_new.$mini_icon_edit.$description,
		'HACK_VERSION' => $hack_version,
		'LONG_DESC' => $long_desc,
		'STATUS' => $status,
		'USER_TRAFFIC' => $user_traffic_out,
		'FILE_SIZE' => $file_size_out,
		'FILE_KLICKS' => $file_klicks,
		'FILE_OVERALL_KLICKS' => $file_overall_klicks,
		'FILE_NAME' => $file_name)
	);
}

$template->assign_vars(array(
	"L_DESCRIPTION" => $lang['Dl_file_description'],
	"L_DETAILS" => $lang['Dl_detail'],
	"L_DL_HACK_AUTHOR" => $lang['Dl_hack_autor'],
	"L_DL_HACK_AUTHOR_WEBSITE" => $lang['Dl_hack_autor_website'],
	"L_DL_HACK_DL_URL" => $lang['Dl_hack_dl_url'],
	"L_DL_MOD_REQUIRE" => $lang['Dl_mod_require'],
	"L_DL_MOD_TEST" => $lang['Dl_mod_test'],
	"L_DL_MOD_TODO" => $lang['Dl_mod_todo'],
	"L_DOWNLOAD" => $lang['Dl_download'],
	"L_FILE_NAME" => $lang['Dl_file_name'],
	"L_KLICKS" => $lang['Dl_klicks'],
	"L_OVERALL_KLICKS" => $lang['Dl_overall_klicks'],
	"L_NAME" => $lang['Dl_name'],
	"L_SIZE" => $lang['Dl_file_size'],

	"ROW_CLASS1" => $theme['td_class1'],
	"ROW_CLASS2" => $theme['td_class2'],

	'U_SEARCH' => '<a href="'.append_sid("search_downloads.$phpEx").'"><img src="'.$images['icon_search'].'" border="0" alt="'.$lang['Search'].'"></a>',
	"U_DL_CAT" => $cat_nav,
	"U_DL_TOP" => $u_dl_top)
);

$template->pparse('body');

include($phpbb_root_path . 'includes/dl_footer.'.$phpEx);

include($phpbb_root_path . 'includes/page_tail.'.$phpEx);

?>