<?php
/***************************************************************************
 *                               dl_rating.php
 *                            -------------------
 *     begin                : Tuesday, Jun. 07 2005
 *     copyright            : (C) 2005 OXPUS
 *     email                : webmaster@oxpus.de
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

define('IN_PHPBB', true);
$phpbb_root_path = './';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);
include($phpbb_root_path . 'includes/bbcode.'.$phpEx);
include($phpbb_root_path . 'includes/functions_post.'.$phpEx);
include($phpbb_root_path . 'includes/functions_downloads.'.$phpEx);

//
// Start session management
$userdata = session_pagestart($user_ip, PAGE_INDEX);
init_userprefs($userdata);

//
// Get the required values
$id = ( $HTTP_POST_VARS['id'] ) ? intval($HTTP_POST_VARS['id']) : intval($HTTP_GET_VARS['id']);
$cat = ( $HTTP_POST_VARS['cat'] ) ? intval($HTTP_POST_VARS['cat']) : intval($HTTP_GET_VARS['cat']);
$dlo = ( $HTTP_POST_VARS['dlo'] ) ? intval($HTTP_POST_VARS['dlo']) : intval($HTTP_GET_VARS['dlo']);
$submit = ( $HTTP_POST_VARS['submit'] ) ? $HTTP_POST_VARS['submit'] : $HTTP_GET_VARS['submit'];
$cancel = ( $HTTP_POST_VARS['cancel'] ) ? $HTTP_POST_VARS['cancel'] : $HTTP_GET_VARS['cancel'];
$rate_point = ( $HTTP_POST_VARS['rate_point'] ) ? intval($HTTP_POST_VARS['rate_point']) : intval($HTTP_GET_VARS['rate_point']);
$submit_success = 0;

//
// Save rating into database after submitting
if ( $submit )
{
	$rate_user_id = $userdata['user_id'];
	$rate_point = round($rate_point, 2);

	$sql = "INSERT INTO ". DL_RATING_TABLE ." (dl_id, user_id, rate_point)
			VALUES ($id, $rate_user_id, '$rate_point')";

	if( !$result = $db->sql_query($sql) )
	{
		message_die(GENERAL_ERROR, 'Could not insert new rating', '', __LINE__, __FILE__, $sql);
	}

	$sql = "SELECT AVG(rate_point) AS rating FROM ". DL_RATING_TABLE ."
		WHERE dl_id = $id
		GROUP BY dl_id";
	if( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, 'Could not query rating information', '', __LINE__, __FILE__, $sql);
	}
	$this_id = $db->sql_fetchrow($result);
	$new_rating = ceil($this_id['rating']);
	$db->sql_freeresult($result);

	$sql = "UPDATE ". DOWNLOADS_TABLE ."
		SET rating = $new_rating
		WHERE id = $id";
	if( !$result = $db->sql_query($sql) )
	{
		message_die(GENERAL_ERROR, 'Could not insert new average rating', '', __LINE__, __FILE__, $sql);
	}

	$submit_success = TRUE;
}

if ( $id == 0 || $userdata['user_level'] == ANONYMOUS || !$userdata['session_logged_in'] || $cancel || $submit_success == TRUE)
{
	$redirect = ($dlo == 1) ? append_sid("dl_overview.$phpEx") : append_sid("dl_details.$phpEx?view=detail&amp;id=$id&amp;cat=$cat");
	redirect($redirect);
}

//
// Start output of page
$page_title = $lang['Dl_Rating'];
include($phpbb_root_path . 'includes/page_header.'.$phpEx);

// Default entry point. Start from here if you start the file!
$sql = "SELECT dl_id FROM " . DL_RATING_TABLE;
if (!$result = $db->sql_query($sql))
{
	message_die(GENERAL_ERROR, 'Could not fetch ratings', '', __LINE__, __FILE__, $sql);
}

$ratings = array();
while ($row = $db->sql_fetchrow($result))
{
	$ratings[$row['file_id']][] = $row['user_id'];
}
$db->sql_freeresult($result);

if (!empty($ratings[$id]) && in_array($userdata['user_id'], $ratings[$id]))
{
	$redirect = ($cat == 0) ? append_sid("dl_overview.$phpEx") : append_sid("downloads.$phpEx?view=detail&amp;id=$id&amp;cat=$cat");

	redirect($redirect);
}

$sql = "SELECT * FROM ". DOWNLOADS_TABLE ."
	WHERE id = $id";
if( !($result = $db->sql_query($sql)) )
{
	message_die(GENERAL_ERROR, 'Could not query download information', '', __LINE__, __FILE__, $sql);
}

while($row = $db->sql_fetchrow($result))
{
	$this_dl = $row;
}
$db->sql_freeresult($result);

$rating = '<select name="rate_point">';
for ( $i = 1; $i <= 10; $i++ )
{
	$rating .= '<option value="'.$i.'">'.$i.'</option>';
}
$rating .= '</select>';

$template->set_filenames(array(
	'body' => 'view_dl_body.tpl')
);

$cat_id = $this_dl['cat'];

$dl_auth = array();
$dl_auth = dl_auth($cat_id, 0);

$index = array();
$index = create_dl_overview_index();

set_auto_traffic();
reset_dl_klicks();

$user_id = $userdata['user_id'];
$username = $userdata['username'];

if ( $userdata['session_logged_in'])
{
	$user_traffic = $userdata['user_traffic'];
}
else
{
	$user_traffic = "0";
}

$description = make_clickable(smilies_pass(stripslashes($this_dl['description'])));
$description = ($this_dl['bbcode_uid'] != '') ? bbencode_second_pass($description, $this_dl['bbcode_uid']) : $description;
$description = str_replace("\n", "\n<br />\n", $description);
$file_name_name = $this_dl['file_name'];
$file_id = $this_dl['id'];
$description = ($this_dl['long_desc'] != "") ? "<a class=\"gen\" href=\"downloads.$phpEx?view=detail&id=" . $file_id . "&cat=" . $this_dl[cat] . "\">" . $description . "</a>" : $description;
$file_klicks = $this_dl['klicks'];
$file_overall_klicks = $this_dl['overall_klicks'];
$file_free = $this_dl['free'];
$file_extern = $this_dl['extern'];
$file_traffic = $this_dl['file_traffic'];
$file_size = $this_dl['file_size'];

if ($file_extern == "0")
{
	if ($file_size < 1024)
	{
		$file_size_out = $file_size . " byte";
	}
	if ($file_size > 1025)
	{
		$file_size_out = bcdiv($file_size,1024,2) . " KB";
	}
	if ($file_size > 1048575)
	{
		$file_size_out = bcdiv($file_size,1048576,2) . " MB";
	}
}
else
{
	$file_size_out = $lang['Dl_not_availible'];
}

$dl_status = array();
$dl_status = get_dl_status($file_size, $file_extern, $file_id, $file_name_name, $file_free, $file_klicks, $file_traffic, $cat_id);

$status = $dl_status['status'];
$file_name = $dl_status['file_name'];

$mini_icon_new = ($this_dl['new_edit'] == 1 && ((time() - $this_dl['change_time']) / 86400) <= $board_config['dl_new_time'] && intval($board_config['dl_new_time']) > 0) ? '<img src="'.$images['icon_minipost_new'].'" border="0" />&nbsp;' : '';
$mini_icon_edit = ($this_dl['new_edit'] == 0 && ((time() - $this_dl['change_time']) / 86400) <= $board_config['dl_new_time'] && intval($board_config['dl_new_time']) > 0) ? '<img src="'.$images['icon_minipost'].'" border="0" />&nbsp;' : '';

$hack_version = '&nbsp;'.$this_dl['hack_version'];

$bbcode_uid = $this_dl['bbcode_uid'];
$long_desc = stripslashes($this_dl['long_desc']);
$long_desc = ($bbcode_uid != '') ? bbencode_second_pass($long_desc, $bbcode_uid) : $long_desc;
$long_desc = smilies_pass($long_desc);
$long_desc = str_replace("\n", "\n<br />\n", $long_desc);

$rating_text = create_rating_img($this_dl['rating']);

$u_dl_top = '&raquo;&nbsp;<a href="'.append_sid("downloads.$phpEx?sort_by=$sort_by&amp;order=$order").'" class="nav">'.$lang['Dl_cat_title'].'</a>&nbsp;&raquo;&nbsp;<span class="nav">'.$lang['Dl_rating'].': '.$description.'</span>';

$s_hidden_fields = '<input type="hidden" name="id" value="'.$file_id.'" />';
$s_hidden_fields .= ($cat > 0) ? '<input type="hidden" name="cat" value="'.$cat.'" />' : '';
$s_hidden_fields .= '<input type="hidden" name="dlo" value="'.$dlo.'" />';

$template->assign_vars(array(
	'L_DESCRIPTION' => $lang['Dl_file_description'],
	'L_DETAILS' => $lang['Dl_detail'],
	'L_DOWNLOAD' => $lang['Downloads'],
	'L_NAME' => $lang['Dl_name'],
	'L_FILE_NAME' => $lang['Dl_file_name'],
	'L_KLICKS' => $lang['Dl_klicks'],
	'L_SIZE' => $lang['Dl_file_size'],
	"L_OVERALL_KLICKS" => $lang['Dl_overall_klicks'],
	'L_DL_GREEN_EXPLAIN' => $lang['Dl_green_explain'],
	'L_DL_GREY_EXPLAIN' => $lang['Dl_grey_explain'],
	'L_DL_RED_EXPLAIN' => sprintf($lang['Dl_red_explain'], $board_config['dl_posts']),
	'L_DL_RED_EXPLAIN_ALT' => sprintf($lang['Dl_red_explain_alt'], $board_config['dl_posts']),
	'L_DL_YELLOW_EXPLAIN' => $lang['Dl_yellow_explain'],

	'L_RATING' => $lang['Dl_rating'],
	'L_SUBMIT' => $lang['Submit'],
	'L_CANCEL' => $lang['Cancel'],

	'GREEN' => $images['Dl_green'],
	'GREY' => $images['Dl_grey'],
	'RED' => $images['Dl_red'],
	'YELLOW' => $images['Dl_yellow'],

	'ROW_CLASS1' => $theme['td_class1'],
	'ROW_CLASS2' => $theme['td_class2'],

	'S_ACTION' => append_sid("dl_rating.$phpEx"),
	'S_HIDDEN_FIELDS' => $s_hidden_fields,

	'U_DL_TOP' => $u_dl_top,
	'U_SEARCH' => '<a href="'.append_sid("search_downloads.$phpEx").'"><img src="'.$images['icon_search'].'" border="0" alt="'.$lang['Search'].'"></a>')
);

$template->assign_block_vars('downloads', array(
	'LONG_DESC' => $long_desc,
	'STATUS' => $status,
	'DESCRIPTION' => $mini_icon_new.$mini_icon_edit.$description,
	'HACK_VERSION' => $hack_version,
	'FILE_NAME' => $file_name,
	'FILE_KLICKS' => $file_klicks,
	'FILE_OVERALL_KLICKS' => $file_overall_klicks,
	'FILE_SIZE' => $file_size_out)
);

$template->assign_block_vars('rating', array(
	'RATING' => $rating,
	'RATING_CURRENT' => $rating_text)
);

$template->pparse('body');

include($phpbb_root_path . 'includes/dl_footer.'.$phpEx);

include($phpbb_root_path . 'includes/page_tail.'.$phpEx);

?>