<?php

define('IN_PHPBB', true);
$phpbb_root_path = './';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);
include($phpbb_root_path . 'includes/bbcode.'.$phpEx);
include($phpbb_root_path . 'includes/functions_post.'.$phpEx);
include($phpbb_root_path . 'includes/functions_downloads.'.$phpEx);

//
// Set page ID for session management
//
$userdata = session_pagestart($user_ip, PAGE_DOWNLOADS);
init_userprefs($userdata);
//
// End session management
//

$download_dir = $board_config['download_dir'];
$params = array('view' => 'view');
while( list($var, $param) = @each($params) )
{
	if ( !empty($HTTP_POST_VARS[$param]) || !empty($HTTP_GET_VARS[$param]) )
	{
		$$var = ( !empty($HTTP_POST_VARS[$param]) ) ? htmlspecialchars($HTTP_POST_VARS[$param]) : htmlspecialchars($HTTP_GET_VARS[$param]);
	}
	else
	{
		$$var = '';
	}
}

$params = array('id' => 'id', 'cat' => 'cat');
while( list($var, $param) = @each($params) )
{
	if ( !empty($HTTP_POST_VARS[$param]) || !empty($HTTP_GET_VARS[$param]) )
	{
		$$var = ( !empty($HTTP_POST_VARS[$param]) ) ? intval($HTTP_POST_VARS[$param]) : intval($HTTP_GET_VARS[$param]);
	}
	else
	{
		$$var = '';
	}
}

if ($cat > 0 && $id > 0 && $view == 'detail')
{
	redirect(append_sid("dl_details.$phpEx?view=detail&amp;cat=".$cat."&amp;id=".$id));
}

$dl_auth = array();
$dl_auth = dl_auth('all_cats', 0);

set_auto_traffic();
reset_dl_klicks();

$start = ( isset($HTTP_GET_VARS['start']) ) ? intval($HTTP_GET_VARS['start']) : 0;
$sort_by = ( $HTTP_POST_VARS['sort_by'] ) ? intval($HTTP_POST_VARS['sort_by']) : intval($HTTP_GET_VARS['sort_by']);
$order = ( $HTTP_POST_VARS['order'] ) ? $HTTP_POST_VARS['order'] : $HTTP_GET_VARS['order'];

//
// Generate page
//
$cat_nav = ($cat != 0) ? create_dl_nav($cat) : '';
$u_dl_top = '&raquo;&nbsp;<a href="'.append_sid("downloads.$phpEx?sort_by=$sort_by&amp;order=$order").'" class="nav">'.$lang['Dl_cat_title'].'</a>';
$dl_jumpbox = '<form action="'.append_sid("downloads.$phpEx?sort_by=$sort_by&amp;order=$order").'" name="dl_jumpbox" method="post"><select name="cat">';
$dl_jumpbox .= make_dl_jumpbox($cat);
$dl_jumpbox .= '</select>&nbsp;<input type="submit" name="submit" value="'.$lang['Go'].'" class="liteoption"></form>';
$index = (!$cat) ? create_dl_index() : create_dl_index($cat);
$index_perm = create_dl_overview_index();

make_jumpbox('viewforum.'.$phpEx);

$page_title = $lang['Downloads'];

include($phpbb_root_path . 'includes/page_header.'.$phpEx);

if (!$cat)
{
	$template->set_filenames(array(
		'body' => 'view_dl_cat_body.tpl')
	);
}
else
{
	$template->set_filenames(array(
		'body' => 'downloads_body.tpl')
	);

	$s_sort_by = '<select name="sort_by">';
	$s_sort_by .= '<option value="0">'.$lang['Dl_default_sort'].'</option>';
	$s_sort_by .= '<option value="1">'.$lang['Dl_file_description'].'</option>';
	$s_sort_by .= '<option value="2">'.$lang['Dl_file_name'].'</option>';
	$s_sort_by .= '<option value="3">'.$lang['Dl_klicks'].'</option>';
	$s_sort_by .= '<option value="4">'.$lang['Dl_free'].'</option>';
	$s_sort_by .= '<option value="5">'.$lang['Dl_extern'].'</option>';
	$s_sort_by .= '<option value="6">'.$lang['Dl_file_size'].'</option>';
	$s_sort_by .= '<option value="7">'.$lang['Last_updated'].'</option>';
	$s_sort_by .= '<option value="8">'.$lang['Dl_rating'].'</option>';
	$s_sort_by .= '</select>';
	$s_sort_by = str_replace('value="'.$sort_by.'">', 'value="'.$sort_by.'" SELECTED>', $s_sort_by);

	$s_order = '<select name="order">';
	$s_order .= '<option value="ASC">'.$lang['Sort_Ascending'].'</option>';
	$s_order .= '<option value="DESC">'.$lang['Sort_Descending'].'</option>';
	$s_order .= '</select>';
	$s_order = str_replace('value="'.$order.'">', 'value="'.$order.'" SELECTED>', $s_order);

	switch ($sort_by)
	{
		case 1:
			$sql_sort_by = 'description';
			break;
		case 2:
			$sql_sort_by = 'file_name';
			break;
		case 3:
			$sql_sort_by = 'klicks';
			break;
		case 4:
			$sql_sort_by = 'free';
			break;
		case 5:
			$sql_sort_by = 'extern';
			break;
		case 6:
			$sql_sort_by = 'file_size';
			break;
		case 7:
			$sql_sort_by = 'change_time';
			break;
		case 8:
			$sql_sort_by = 'rating';
			break;
		default:
			$sql_sort_by = 'sort';
	}

	$sql_order = $order;
}

$user_id = $userdata['user_id'];
$username = $userdata['username'];
if ( $userdata['session_logged_in'])
{
	$user_traffic = $userdata['user_traffic'];
}
else
{
	$user_traffic = "0";
}

// get the number of files in each cat
$sql = "SELECT cat, count(*) as total FROM " . DOWNLOADS_TABLE . "
	GROUP BY cat";	

if (!$result = $db->sql_query($sql))
{
	message_die(GENERAL_ERROR, 'Could not count downloads in categories', '', __LINE__, __FILE__, $sql);
}
$total_in_cat = array();
while ($row = $db->sql_fetchrow($result))
{
	$total_in_cat[$row['cat']] = $row['total'];
}
$db->sql_freeresult($result);

if (count($index) > 0)
{
	$i = 0;
	foreach(array_keys($index) as $key)
	{
		$cat_id = $key;
		$cat_name = $index[$cat_id]['cat_name'];
		$cat_desc = $index[$cat_id]['description'];
		$cat_view = $index[$cat_id]['nav_path'];
		$cat_sublevel = $index[$cat_id]['sublevel'];

		$count_new = $count_edit = 0;
		$mini_icon_new = $mini_icon_edit = '';

		$sql_mini_icon = "SELECT new_edit, change_time FROM " . DOWNLOADS_TABLE . "
				  WHERE cat = $cat_id";
		if (!$result_mini_icon = $db->sql_query($sql_mini_icon))
		{
			message_die(GENERAL_ERROR, 'Could not fetch data for new/changes downloads', '', __LINE__, __FILE__, $sql_mini_icon);
		}

		while ($row_mini_icon = $db->sql_fetchrow($result_mini_icon))
		{
			if ($row_mini_icon['new_edit'] == 1)
			{
				$count_new += (((time() - $row_mini_icon['change_time'])) / 86400 <= $board_config['dl_new_time'] && $board_config['dl_new_time'] > 0) ? 1 : 0;
			}

			if ($row_mini_icon['new_edit'] == 0)
			{
				$count_edit += (((time() - $row_mini_icon['change_time']) / 86400) <= $board_config['dl_edit_time'] && $board_config['dl_edit_time'] > 0) ? 1 : 0;
			}

		}
		$db->sql_freeresult($result_mini_icon);

		if ($count_edit > 0)
		{
			$mini_icon_edit = '<img src="'.$images['icon_minipost'].'" border="0" />&nbsp;';
		}

		if ($count_new > 0)
		{
			$mini_icon_new = '<img src="'.$images['icon_minipost_new'].'" border="0" />&nbsp;';
		}

		$row_class = ( !($i % 2) ) ? $theme['td_class1'] : $theme['td_class2'];

		if ($cat)
		{
			$template->set_filenames(array(
				'subcats' => 'view_dl_subcat_body.tpl')
			);

			$block = 'subcats';

			$template->assign_vars(array(
				"L_DESCRIPTION" => $lang['Dl_file_description'],
				"L_DL_CAT" => $lang['Dl_cat_name'],
				"L_DL_FILES" => $lang['Dl_cat_files'])
			);
		}
		else
		{
			$block = 'downloads';
		}

		$template->assign_block_vars($block, array(
			'U_CAT_VIEW' => $cat_view,
			'ROW_CLASS' => $row_class,
			'CAT_DESC' => $cat_desc,
			'CAT_NAME' => $cat_name,
			'SUBLEVEL' => $cat_sublevel,
			"CAT_DL" => $total_in_cat[$cat_id],
			'MINI_IMG' => $mini_icon_new . $mini_icon_edit)
		);

		$i++;

		if ($cat)
		{
			$template->assign_var_from_handle('SUBCAT_BOX', 'subcats');
		}
	}
	$sql = '';
}

if ($cat)
{
	// <!-- Pagination Addon -->
	$total_downloads = $total_in_cat[$cat];

	if ($total_downloads > 0)
	{
		$pagination = generate_pagination("downloads.$phpEx?cat=$cat&amp;sort_by=$sort_by&amp;order=$order", $total_downloads, $board_config['dl_links_per_page'], $start). '&nbsp;';

		$template->assign_vars(array(
		   'PAGINATION' => $pagination,
		   'PAGE_NUMBER' => sprintf($lang['Page_of'], ( floor( $start / intval($board_config['dl_links_per_page']) ) + 1 ), ceil( $total_downloads / intval($board_config['dl_links_per_page']) )),
		   'L_GOTO_PAGE' => $lang['Goto_page'])
		);

		$sql = "SELECT * FROM " . DOWNLOADS_TABLE . "
			WHERE cat = $cat
			ORDER BY $sql_sort_by $sql_order
			LIMIT $start, ". $board_config['dl_links_per_page'];
	}
	// <!-- Pagination Addon -->
}

if( $sql != '' && !($result = $db->sql_query($sql)) )
{
        message_die(GENERAL_ERROR, 'Could not query downloads', '', __LINE__, __FILE__, $sql);
}

$i = 0;

if (($cat && $total_downloads > 0))
{
	while ($sql != '' && $row = $db->sql_fetchrow($result))
	{
		$cat_id = $row['cat'];

		$description = make_clickable(smilies_pass(stripslashes($row['description'])));
		$description = ($row['bbcode_uid'] != '') ? bbencode_second_pass($description, $row['bbcode_uid']) : $description;
		$description = str_replace("\n", "\n<br />\n", $description);
		$file_id = $row['id'];
		$description = ($row['long_desc'] != "") ? "<a class=\"gen\" href=\"dl_details.$phpEx?view=detail&amp;id=" . $file_id . "&amp;cat=" . $row[cat] . "\">" . $description . "</a>" : $description;
		$file_klicks = $row['klicks'];
                $file_overall_klicks = $row['overall_klicks'];
		$file_free = $row['free'];
		$file_extern = $row['extern'];
		$file_traffic = $row['file_traffic'];
		$file_size = $row['file_size'];
		$file_name_name = $row['file_name'];

		if ($file_extern == "0")
		{
			if ($file_size < 1024)
			{
				$file_size_out = $file_size . " byte";
			}
			if ($file_size > 1025)
			{
				$file_size_out = bcdiv($file_size,1024,2) . " KB";
			}
			if ($file_size > 1048575)
			{
				$file_size_out = bcdiv($file_size,1048576,2) . " MB";
			}
		}
		else
		{
			$file_size_out = $lang['Dl_not_availible'];
		}

		$dl_status = array();
		$dl_status = get_dl_status($file_size, $file_extern, $file_id, $file_name_name, $file_free, $file_klicks, $file_traffic, $cat_id);

		$status = $dl_status['status'];
		$file_name = $dl_status['file_name'];

		$mini_icon_new = ($row['new_edit'] == 1 && ((time() - $row['change_time']) / 86400) <= $board_config['dl_new_time'] && intval($board_config['dl_new_time']) > 0) ? '<img src="'.$images['icon_minipost_new'].'" border="0" />&nbsp;' : '';
		$mini_icon_edit = ($row['new_edit'] == 0 && ((time() - $row['change_time']) / 86400) <= $board_config['dl_new_time'] && intval($board_config['dl_new_time']) > 0) ? '<img src="'.$images['icon_minipost'].'" border="0" />&nbsp;' : '';

		$cat_name = $index[$cat_id]['cat_name'];
		$cat_view = $index[$cat_id]['nav_path'];
		$cat_desc = $index[$cat_id]['description'];

		$hack_version = '&nbsp;'.$row['hack_version'];

		$bbcode_uid = $row['bbcode_uid'];
		$long_desc = stripslashes($row['long_desc']);
		$long_desc = ($bbcode_uid != '') ? bbencode_second_pass($long_desc, $bbcode_uid) : $long_desc;
		$long_desc = smilies_pass($long_desc);
		$long_desc = str_replace("\n", "\n<br />\n", $long_desc);

		$row_class = ( !($i % 2) ) ? $theme['td_class1'] : $theme['td_class2'];

		if ($cat)
		{
			$sql_rate = "SELECT dl_id, user_id FROM " . DL_RATING_TABLE;
			if (!$result_rate = $db->sql_query($sql_rate))
			{
				message_die(GENERAL_ERROR, 'Could not fetch ratings', '', __LINE__, __FILE__, $sql_rate);
			}

			$ratings = array();
			while ($row_rate = $db->sql_fetchrow($result_rate))
			{
				$ratings[$row_rate['dl_id']][] = $row_rate['user_id'];
			}
			$db->sql_freeresult($result_rate);

			$rating_points = $row['rating'];

			if ($userdata['user_id'] == ANONYMOUS)
			{
				$rating_text = '';
			}
			else if ($rating_points == 0 || !@in_array($userdata['user_id'], $ratings[$file_id]))
			{
				$rating_text = sprintf($lang['Dl_klick_to_rate'], '<a href="'.append_sid("dl_rating.$phpEx?id=$file_id&amp;cat=$cat_id&amp;dlo=0").'" class="gen">', '</a>');
			}
			else
			{
				$rating_text = '';
			}

			$rating_text = create_rating_img($rating_points) . '<br />' . $rating_text;
		}

		$template->assign_block_vars('downloads', array(
			'U_CAT_VIEW' => $cat_view,
			"CAT_NAME" => ((!$cat) ? $mini_icon_new.$mini_icon_edit : '').$cat_name,
			"CAT_ID" => $cat_id,
			"CAT_DL" => $total_downloads,
			"CAT_DESC" => $cat_desc,
			'ROW_CLASS' => $row_class,
			"ROW_CLASS1" => $theme['td_class1'],
			"ROW_CLASS2" => $theme['td_class2'],
			'DESCRIPTION' => (($cat) ? $mini_icon_new.$mini_icon_edit : '').'<b>'.$description.'</b>',
			'HACK_VERSION' => $hack_version,
			'LONG_DESC' => $long_desc,
			'RATING_STRING' => $rating_text,
			'STATUS' => $status,
			'FILE_SIZE' => $file_size_out,
			'FILE_KLICKS' => $file_klicks,
                        'FILE_OVERALL_KLICKS' => $file_overall_klicks)
		);

		$i++;
	}
}

if ($i > 0)
{
	$template->assign_block_vars('download_rows', array());
}

$template->assign_vars(array(
	"L_DESCRIPTION" => $lang['Dl_file_description'],
	"L_DETAILS" => $lang['Dl_detail'],
	"L_DL_CAT" => $lang['Dl_cat_name'],
	"L_DL_FILES" => $lang['Dl_cat_files'],
	"L_DL_HACK_AUTHOR" => $lang['Dl_hack_autor'],
	"L_DL_HACK_AUTHOR_WEBSITE" => $lang['Dl_hack_autor_website'],
	"L_DL_HACK_DL_URL" => $lang['Dl_hack_dl_url'],
	"L_DL_HACK_VERSION" => $lang['Dl_hack_version'],
	"L_DL_MOD_DESC" => $lang['Dl_mod_desc'],
	"L_DL_MOD_LIST" => $lang['Dl_mod_list'],
	"L_DL_MOD_REQUIRE" => $lang['Dl_mod_require'],
	"L_DL_MOD_TEST" => $lang['Dl_mod_test'],
	"L_DL_MOD_TODO" => $lang['Dl_mod_todo'],
	"L_DL_MOD_WARNING" => $lang['Dl_mod_warning'],
	"L_DL_PATH" =>  $lang['Dl_cat_path'],
	"L_DOWNLOAD" => $lang['Dl_download'],
	"L_FILE_NAME" => $lang['Dl_file_name'],
	"L_INFO" => $lang['Dl_info'],
	"L_KLICKS" => $lang['Dl_klicks'],
	"L_OVERALL_KLICKS" => $lang['Dl_overall_klicks'],
	"L_NAME" => $lang['Dl_name'],
	"L_SIZE" => $lang['Dl_file_size'],
	"L_RATING" => $lang['Dl_rating'],
	"L_STATUS" => $lang['Download_status'],
	"L_SORT_BY" => $lang['Sort_by'],
	"L_ORDER" => $lang['Order'],

	"ROW_1" => $theme['td_class1'],
	"ROW_2" => $theme['td_class2'],

	"S_SORT_BY" => $s_sort_by,
	"S_ORDER" => $s_order,

	"T_DL_CAT" => ($cat)? $row['cat_name'] : $lang['Dl_cat_name'],

	"U_DOWNLOADS" => append_sid("downloads.$phpEx?start=$start&amp;cat=$cat"),
	'U_SEARCH' => '<a href="'.append_sid("search_downloads.$phpEx").'"><img src="'.$images['icon_search'].'" border="0" alt="'.$lang['Search'].'"></a>',
	"U_DL_CAT" => $cat_nav,
	"U_DL_TOP" => $u_dl_top)
);

$template->pparse('body');

include($phpbb_root_path . 'includes/dl_footer.'.$phpEx);

include($phpbb_root_path . 'includes/page_tail.'.$phpEx);

?>